﻿//
// Parago Media GmbH & Co. KG, Jürgen Bäurle (jbaurle@parago.de)
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
// TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
// CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
// DEALINGS IN THE SOFTWARE.
//

using System.Reflection;
using DotLiquid;

namespace SP2010HTML2PDF
{
	internal class SPPropertyDrop : SPDropBase
	{
		public SPPropertyDrop()
		{
		}

		public SPPropertyDrop(object genericObject)
		{
			DropableObject = genericObject;
		}

		public override object BeforeMethod(string method)
		{
			if(!string.IsNullOrEmpty(method) && DropableObject != null && !DropableObject.GetType().IsValueType)
			{
				PropertyInfo pi = DropableObject.GetType().GetProperty(method);

				if(pi != null)
					return DropHelper.MayConvertToDrop(pi.GetValue(DropableObject, null));
			}

			return null;
		}
	}
}
